/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/* 
 *	explode -
 *		Translate vertexes along their normals
 *
 *			Paul Haeberli - 1990
 */
#include "stdio.h"
#include "sgiobj.h"
#include "math.h"

main(argc,argv)
int argc;
char **argv;
{
    sgiobj *obj;
    float val;

    if(argc<4) {
	fprintf(stderr,"usage: explode in.sgo out.sgo val\n");
	exit(1);
    }
    obj = readsgiobj(argv[1]);
    val = atof(argv[3]);
    explodeobj(obj,val);
    writesgiobj(argv[2],obj);
    exit(0);
}

/*
 *    	explodeobj follows
 *
 */
static float expfactor;

static expfunc(v)
float *v;
{
    v[OFFSET_POINT+0] += expfactor*v[OFFSET_NORMAL+0];
    v[OFFSET_POINT+1] += expfactor*v[OFFSET_NORMAL+1];
    v[OFFSET_POINT+2] += expfactor*v[OFFSET_NORMAL+2];
}

explodeobj(obj,exp)
sgiobj *obj;
float exp;
{
    expfactor = exp;
    applytoverts(obj,expfunc);
}
