/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/* 
 *	tlsub -
 *		Fit a triangle list into a -1.0..1.0 -1.0..1.0 space.
 *
 *			Paul Haeberli - 1990
 */
#include "math.h"
#include "stdio.h"
#include "vect.h"
#include "trilist.h"

main(argc,argv)
int argc;
char **argv;
{
    float xmin, xmax, ymin, ymax;

    if(argc<3) {
	fprintf(stderr,"usage: tlsub in.tl out.tl xmin xmax ymin ymax\n");
	exit(1);
    }
    xmin = atof(argv[3]);
    xmax = atof(argv[4]);
    ymin = atof(argv[5]);
    ymax = atof(argv[6]);
    tlsub(argv[1],argv[2],xmin,xmax,ymin,ymax);
    exit(0);
}

tlsub(inname,outname,xmin,xmax,ymin,ymax)
char *inname, *outname;
float xmin,xmax,ymin,ymax;
{
    float txmin, txmax, tymin, tymax;
    trilisttri tri;
    int i, ntri;
    FILE *outf;
    short magic;

    ntri = tlopen(inname);
    outf = fopen(outname,"w");
    magic = TLMAGIC;
    fwrite(&magic,sizeof(short),1,outf);
    for(i=0; i<ntri; i++) {
	tlread(&tri);
	txmin = tymin = 1000.0;
	txmax = tymax = -1000.0;

	if(txmin>tri.x0)
	    txmin=tri.x0;
	if(txmax<tri.x0)
	    txmax=tri.x0;
	if(tymin>tri.y0)
	    tymin=tri.y0;
	if(tymax<tri.y0)
	    tymax=tri.y0;

	if(txmin>tri.x1)
	    txmin=tri.x1;
	if(txmax<tri.x1)
	    txmax=tri.x1;
	if(tymin>tri.y1)
	    tymin=tri.y1;
	if(tymax<tri.y1)
	    tymax=tri.y1;

	if(txmin>tri.x2)
	    txmin=tri.x2;
	if(txmax<tri.x2)
	    txmax=tri.x2;
	if(tymin>tri.y2)
	    tymin=tri.y2;
	if(tymax<tri.y2)
	    tymax=tri.y2;
    	if(txmax>xmin && txmin<xmax && tymax>ymin && tymin<ymax)
	    fwrite(&tri,sizeof(trilisttri),1,outf);
    }
    tlclose();
    fclose(outf);
}
