/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/* 
 *	warpnorm -
 *		Add salt to object normals.
 *
 *			Paul Haeberli - 1990
 */
#include "stdio.h"
#include "vect.h"
#include "sgiobj.h"

static saltnorm();

#define NSCALE	10.0

float fnoise3();

main(argc,argv)
int argc;
char **argv;
{
    sgiobj *obj;
    float freq, mag;

    if(argc<4) {
	fprintf(stderr,"usage: warpnorm in.sgo out.sgo freq mag\n");
	exit(1);
    }
    obj = readsgiobj(argv[1]);
    freq = atof(argv[3]);
    mag = atof(argv[4]);
    warpnormobj(obj,freq,mag);
    writesgiobj(argv[2],obj);
    exit(0);
}

/*
 *    	warpnorm follows
 *
 */
static float warpmag;
static float warpfreq;

static warpfunc(v)
float *v;
{
    saltnorm(v+OFFSET_NORMAL,v+OFFSET_POINT);
}

warpnormobj(obj,freq,mag)
sgiobj *obj;
float freq, mag;
{
    warpmag = mag;
    warpfreq = freq;
    applytoverts(obj,warpfunc);
}

static float mynoise(offset,freq,p)
float offset, freq;
vect *p;
{
    return fnoise3(warpfreq*(p->x+offset),
		   warpfreq*(p->y-offset),
		   warpfreq*(p->z-offset));
}

static saltnorm(n,p)
vect *n, *p;
{
    n->x += warpmag*mynoise(1.0,warpfreq,p);
    n->y += warpmag*mynoise(2.0,warpfreq,p);
    n->z += warpmag*mynoise(3.0,warpfreq,p);
    vnormal(n);
}
